#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include "wme_plugin.h"
#include "SteamPlugin.h"


BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
    return TRUE;
}

//////////////////////////////////////////////////////////////////////////
// return some info about this plugin
extern "C" __declspec(dllexport) void GetPluginInfo(SWmePluginInfo* PluginInfo)
{
	strcpy(PluginInfo->Description, "WME Steamworks API plugin");
	sprintf(PluginInfo->WmeVersion, "%d.%d.%d", WME_VERSION_MAJOR, WME_VERSION_MINOR, WME_VERSION_BUILD);
	sprintf(PluginInfo->PluginVersion, "%d.%d.%d", 1, 0, 0);
}

//////////////////////////////////////////////////////////////////////////
// tell WME what scripting classes are offered by this plugin
extern "C" __declspec(dllexport) const char* GetSupportedClasses()
{
	return "SteamAPI";
}

//////////////////////////////////////////////////////////////////////////
// establish the interface between WME and plugin
// i.e. tell WME which functions to call in different situations
extern "C" __declspec(dllexport) void GetClassDefinition(const char* ClassName, SWmeClassDef* ClassDef)
{
	if (strcmp(ClassName, "SteamAPI") == 0)
	{
		ClassDef->Construct      = SteamPlugin::Construct;
		ClassDef->ConstructEmpty = SteamPlugin::ConstructEmpty;
		ClassDef->Destruct       = SteamPlugin::Destruct;
		ClassDef->CallMethod     = SteamPlugin::CallMethod;
		ClassDef->SetProperty    = SteamPlugin::SetProperty;
		ClassDef->GetProperty    = SteamPlugin::GetProperty;
		ClassDef->Serialize      = SteamPlugin::Serialize;
		ClassDef->ReceiveEvent   = SteamPlugin::ReceiveEvent;
	}
}
